# Utility class to run a Ycon instance and convert the strings returned
# into array structures suitable for further processing.

class BeDrop
 def initialize
  @p = IO.popen("Ycon")
  end

 # The 'each' method assembles the lines received from Ycon
 # into a string, and evaluates that to create an array structure
 # representing the dropped message.
 # Caution: it expects "sensible" text strings -- which will normally be
 # the case for dropped-message entries.  However, a pasted clipboard item
 # could contain anything, and inappropriate characters such as extra quotes
 # may cause an error in 'eval'.
 def each
   mstr = 1
   until mstr == ""
    mstr = ""
    @p.each{|s| mstr<<s
     break if s == "]\n"
    }
    yield eval(mstr)
   end
  end

 # 'each_url' looks for relevant fields in dropped links or bookmarks,
 # and extracts the URL string.  Yields nothing if no URL is found.
 def each_url
   each{|m| next if not m
     if ((u = m.assoc("be:url")) ||
      ((u = m.assoc("text/plain")) && u[1] == "MIME")) then yield u[2]
     elsif (u = m.assoc("refs")) && (u[1] == "RREF") then
      file = u[2][1]
      if %x(catattr BEOS:TYPE "#{file}").include? "application/x-vnd.Be-bookmark" then
      	yield %x(catattr META:url "#{file}").split(" : ")[-1].chop
       end
     end
   }
  end
end

